#!/bin/bash

verbose=0
if [ x$1 = x"" ]; then 
    export verbose=0
else
    export verbose=1
fi

source UnitTest.sh
testdir=`dirname $0`
#echo testdir is  $testdir 
#source $testdir/UnitTest.sh
scadat=$testdir/../scadat/scadat
ExecuteCmdEquals "$scadat localhost -vv" "open: TANGO_HOST=localhost:10000"
ExecuteCmdEquals "$scadat localhost 10000 -vv" "open: TANGO_HOST=localhost:10000"
ExecuteCmdEquals "$scadat Unknown -v" "Could not connect to Unknown:10000"
ExecuteCmdEquals "$scadat -ls Unknown -v" "Could not connect to Unknown:10000"
ExecuteCmdEquals "$scadat -r simulator/test/ramp" "Amplitude
State
Status
Init
State
Status
UpdateAttributes"

ExecuteCmdContains "$scadat -w sys/tg_test/1 DevFloat 12.34" "12.34"
ExecuteCmdContains "$scadat -w sys/tg_test/1 DevDouble 12.34" "12.34"
ExecuteCmdContains "$scadat -w sys/tg_test/1 DevLong 1234" "1234"
ExecuteCmdContains "$scadat -w sys/tg_test/1 DevLong64 1234" "1234"
ExecuteCmdContains "$scadat -w sys/tg_test/1 DevULong64 1234" "1234"
ExecuteCmdContains "$scadat -w sys/tg_test/1 DevULong 1234" "1234"
ExecuteCmdContains "$scadat -w sys/tg_test/1 DevBoolean 1" "True"
ExecuteCmdContains "$scadat -w sys/tg_test/1 DevShort 1234" "1234"
ExecuteCmdContains "$scadat -w sys/tg_test/1 DevUShort 1234" "1234"
ExecuteCmdContains "$scadat -w sys/tg_test/1 DevString 'my string'" "my string"
ExecuteCmdContains "$scadat -w sys/tg_test/1 DevVarLongArray '1 2 3 4'" "1 2 3 4"
ExecuteCmdContains "$scadat -w sys/tg_test/1 DevVarLong64Array '1 2 3 4'" "1 2 3 4"
ExecuteCmdContains "$scadat -w sys/tg_test/1 DevVarULong64Array '1 2 3 4'" "1 2 3 4"
ExecuteCmdContains "$scadat -w sys/tg_test/1 DevVarFloatArray '1.123456 2.2 3.3 4.4'" "1.123456"
ExecuteCmdContains "$scadat -w sys/tg_test/1 DevVarDoubleArray '1.123456 2.2 3.3 4.4'" "1.123456"
ExecuteCmdContains "$scadat -w sys/tg_test/1 DevVarUShortArray '1 2 3 4'" "1 2 3 4"
ExecuteCmdContains "$scadat -w sys/tg_test/1 DevVarShortArray '1 2 3 4'" "1 2 3 4"
ExecuteCmdContains "$scadat -w sys/tg_test/1 DevVarStringArray 'string1 string2 string3 string4'" "'string1', 'string2', 'string3', 'string4'"
ExecuteCmdContains "$scadat -w sys/tg_test/1 DevVoid None" "None"

# attribute_read_all
ExecuteCmdContains "$scadat -r sys/tg_test/1 -v | grep long_scalar_rww" "long_scalar_rww <attr> write"
ExecuteCmdEquals "$scadat -r sys/tg_test/1 -v | grep ulong_image_ro" "ulong_image_ro <attr> write(None)"

# attribute_read_single
ExecuteCmdContains "$scadat -r sys/tg_test/1 short_scalar_rww -v | grep 'short_scalar_rww'" "short_scalar_rww"
# Read 1 command
ExecuteCmdEquals "$scadat -r sys/tg_test/1 DevVarUShortArray -v" "DevVarUShortArray cmd"
# Read 1 attribute
ExecuteCmdContains "$scadat -r sys/tg_test/1 ushort_scalar -v" "ushort_scalar"
ExecuteCmdEquals "$scadat -r sys/tg_test/1 ushort_scalar_error -v" "Error reading attr or cmd ushort_scalar_error"
ExecuteCmdContains "$scadat -r sys/tg_test/1 long_scalar_w -v" "long_scalar_w"
# Write/Read Attributes
ExecuteCmdEquals "$scadat -w sys/tg_test/1 long_scalar_w 4321" "long_scalar_w->4321"
ExecuteCmdEquals "$scadat -r sys/tg_test/1 long_scalar_w -v" "long_scalar_w 4321"
ExecuteCmdEquals "$scadat -w sys/tg_test/1 long_scalar_w 1234" "long_scalar_w->1234"
ExecuteCmdEquals "$scadat -r sys/tg_test/1 long_scalar_w -v" "long_scalar_w 1234"

ExecuteCmdEquals "$scadat -w sys/tg_test/1 short_scalar_w 4321" "short_scalar_w->4321"
ExecuteCmdEquals "$scadat -r sys/tg_test/1 short_scalar_w -v" "short_scalar_w 4321"

ExecuteCmdEquals "$scadat -w sys/tg_test/1 string_scalar 'my string 123'" "string_scalar->my string 123"
ExecuteCmdEquals "$scadat -r sys/tg_test/1 string_scalar -v" "string_scalar my string 123"
#### Not supported - yet
#ExecuteCmdContains "$scadat -w sys/tg_test/1 DevVarDoubleStringArray '1 2 3 4'" "1 2 3 4"
#ExecuteCmdContains "$scadat -w sys/tg_test/1 DevVarCharArray '1 2 3 4'" "1 2 3 4"
#ExecuteCmdContains "$scadat -w sys/tg_test/1 DevVarLongStringArray 1234" "1234"
echo "epics tests:"
export SCADAT_HOST="EPICS"
ExecuteCmdContains "$scadat -r 'CO_TEST:CLOCK1:SEC1' -v" "CO_TEST:CLOCK1:SEC1"
