#   author:martinmhan@yahoo.com date:  22/04/2014
#   scadat is a bash command line interface to the tango scada (and in future epics)
#   Copyright (C) <2014>  <Martin Mohan>
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software Foundation,
#   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

import re,sys
import pkg_resources  # part of setuptools
class scadat_base(object):
    def __init__(self,verbose=0):
        """Open connection to host (host:port)or return error if not found"""
        super(scadat_base, self).__init__()
        self.dummy = 'dummyvalue'
        self.version = pkg_resources.require("scadat")[0].version
        self.verbose = verbose
    def info(self):
        """print scada specific information"""
        raise NotImplementedError("Please Implement this method")
    def list(self):
        """list of devices for this scada"""
        raise NotImplementedError("Please Implement this method")
    def read(self,deviceName,attr_name=None):
        """Read the deviceName
        e.g. scadat -r aa/bb/cc status
        attr_name=None print all attributes"""
        raise NotImplementedError("Please Implement this method")
    def write(self,deviceName,attr_name=None,value=None):
        """Write to deviceName
        attr_name=None print all writeable attr_name\n\
        attr_val=None print all writeable values for attr_name\
        """
        raise NotImplementedError("Please Implement this method")

    def stdout(self,string_value,v=0):
        if self.verbose==v:
            print string_value

# When using stderr unittest does not work
    def stderr(self,string_value,v=0):
        if self.verbose==v:
            sys.stderr.write(string_value+"\n")

    # Use v for more verbose error handling
    def handle_exception(self,e,message="Exception",v=0):
        """ Handle exception"""
#        v=self.verbose
        self.stdout(message)
        if self.verbose>=1:
            self.stdout(message+"\n"+str(e),self.verbose)


# redirect stdout
#import cStringIO
#old_stdout = sys.stdout
#mystdout = sys.stdout = cStringIO.StringIO()
#print "hello_world"
#sys.stdout = old_stdout
#sys.stdout.write(mystdout.getvalue())
